/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreLanguagedefsOrphansRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreLanguagedefsOrphans extends TableImpl<VCoreLanguagedefsOrphansRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_core_languagedefs_orphans</code>
     */
    public static final VCoreLanguagedefsOrphans V_CORE_LANGUAGEDEFS_ORPHANS = new VCoreLanguagedefsOrphans();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreLanguagedefsOrphansRecord> getRecordType() {
        return VCoreLanguagedefsOrphansRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_languagedefs_orphans.lang_key</code>.
     */
    public final TableField<VCoreLanguagedefsOrphansRecord, String> LANG_KEY = createField(DSL.name("lang_key"), SQLDataType.CLOB, this, "");

    private VCoreLanguagedefsOrphans(Name alias, Table<VCoreLanguagedefsOrphansRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreLanguagedefsOrphans(Name alias, Table<VCoreLanguagedefsOrphansRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
         create view "v_core_languagedefs_orphans" as  SELECT t_core_translation_key.translation_key AS lang_key
           FROM common_dd.t_core_translation_key
        EXCEPT
         SELECT t_core_translation.fk_trans_key AS lang_key
           FROM common_dd.t_core_translation
        EXCEPT
         SELECT t_core_element_hierarchy.hier_lang AS lang_key
           FROM common_dd.t_core_element_hierarchy
        EXCEPT
         SELECT t_core_missingmaster.fk_lang AS lang_key
           FROM common_dd.t_core_missingmaster
        EXCEPT
         SELECT t_core_valueparam.param_key AS lang_key
           FROM common_dd.t_core_valueparam
        EXCEPT
         SELECT t_core_elementtype.elementtype_lang AS lang_key
           FROM common_dd.t_core_elementtype
        EXCEPT
         SELECT t_input_help.inputhelp_descr AS lang_key
           FROM common_dd.t_input_help
        EXCEPT
         SELECT t_input_type.inputtype_descr AS lang_key
           FROM common_dd.t_input_type;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_languagedefs_orphans</code>
     * table reference
     */
    public VCoreLanguagedefsOrphans(String alias) {
        this(DSL.name(alias), V_CORE_LANGUAGEDEFS_ORPHANS);
    }

    /**
     * Create an aliased <code>common_dd.v_core_languagedefs_orphans</code>
     * table reference
     */
    public VCoreLanguagedefsOrphans(Name alias) {
        this(alias, V_CORE_LANGUAGEDEFS_ORPHANS);
    }

    /**
     * Create a <code>common_dd.v_core_languagedefs_orphans</code> table
     * reference
     */
    public VCoreLanguagedefsOrphans() {
        this(DSL.name("v_core_languagedefs_orphans"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreLanguagedefsOrphans as(String alias) {
        return new VCoreLanguagedefsOrphans(DSL.name(alias), this);
    }

    @Override
    public VCoreLanguagedefsOrphans as(Name alias) {
        return new VCoreLanguagedefsOrphans(alias, this);
    }

    @Override
    public VCoreLanguagedefsOrphans as(Table<?> alias) {
        return new VCoreLanguagedefsOrphans(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLanguagedefsOrphans rename(String name) {
        return new VCoreLanguagedefsOrphans(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLanguagedefsOrphans rename(Name name) {
        return new VCoreLanguagedefsOrphans(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLanguagedefsOrphans rename(Table<?> name) {
        return new VCoreLanguagedefsOrphans(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguagedefsOrphans where(Condition condition) {
        return new VCoreLanguagedefsOrphans(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguagedefsOrphans where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguagedefsOrphans where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguagedefsOrphans where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguagedefsOrphans where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguagedefsOrphans where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguagedefsOrphans where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguagedefsOrphans where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguagedefsOrphans whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguagedefsOrphans whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
